<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:13 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>IncrementalTaskInputs (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="IncrementalTaskInputs (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li><a href="../../../../../org/gradle/api/tasks/incremental/InputFileDetails.html" title="interface in org.gradle.api.tasks.incremental"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/tasks/incremental/IncrementalTaskInputs.html" target="_top">Frames</a></li>
<li><a href="IncrementalTaskInputs.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.tasks.incremental</div>
<h2 title="Interface IncrementalTaskInputs" class="title">Interface IncrementalTaskInputs</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../../org/gradle/api/NonExtensible.html" title="annotation in org.gradle.api">@NonExtensible</a>
public interface <span class="strong">IncrementalTaskInputs</span></pre>
<div class="block">Provides access to any input files that need to be processed by an incremental task.
 <p>
 An incremental task action is one that accepts a single <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html" title="interface in org.gradle.api.tasks.incremental"><code>IncrementalTaskInputs</code></a> parameter.
 The task can then provide an action to execute for all input files that are out of date with respect to the previous execution of the task,
 and a separate action for all input files that have been removed since the previous execution.

 <pre class='autoTested'>
 class IncrementalReverseTask extends DefaultTask {
      @InputDirectory
      def File inputDir

      @OutputDirectory
      def File outputDir

      @TaskAction
      void execute(IncrementalTaskInputs inputs) {
          if (!inputs.incremental)
              project.delete(outputDir.listFiles())

          inputs.outOfDate { change -&gt;
              def targetFile = project.file("$outputDir/${change.file.name}")
              targetFile.text = change.file.text.reverse()
          }

          inputs.removed { change -&gt;
              def targetFile = project.file("$outputDir/${change.file.name}")
              if (targetFile.exists()) {
                  targetFile.delete()
              }
          }
      }
  }
 </pre>

 <p>
 In the case where Gradle is unable to determine which input files need to be reprocessed, then all of the input files will be reported as <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a>.
 Cases where this occurs include:
 <ul>
     <li>There is no history available from a previous execution.</li>
     <li>An <a href="../../../../../org/gradle/api/tasks/TaskOutputs.html#upToDateWhen(groovy.lang.Closure)"><code>TaskOutputs.upToDateWhen(groovy.lang.Closure)</code></a> criteria added to the task returns <code>false</code>.</li>
     <li>An <a href="../../../../../org/gradle/api/tasks/Input.html" title="annotation in org.gradle.api.tasks"><code>Input</code></a> property has changed since the previous execution.</li>
     <li>One or more output files have changed since the previous execution.</li>
 </ul>

 Note that this is a stateful API:
 <ul>
     <li><a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a> and <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#removed(org.gradle.api.Action)"><code>removed(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a> can each only be executed a single time per <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html" title="interface in org.gradle.api.tasks.incremental"><code>IncrementalTaskInputs</code></a> instance.</li>
     <li><a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a> must be executed before <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#removed(org.gradle.api.Action)"><code>removed(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a> is called.</li>
 </ul></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#isIncremental()">isIncremental</a></strong>()</code>
<div class="block">Indicates if it was possible for Gradle to determine which exactly input files were out of date compared to a previous execution.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)">outOfDate</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/tasks/incremental/InputFileDetails.html" title="interface in org.gradle.api.tasks.incremental">InputFileDetails</a>&gt;&nbsp;outOfDateAction)</code>
<div class="block">Executes the action for all of the input files that are out-of-date since the previous task execution.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#removed(org.gradle.api.Action)">removed</a></strong>(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/tasks/incremental/InputFileDetails.html" title="interface in org.gradle.api.tasks.incremental">InputFileDetails</a>&gt;&nbsp;removedAction)</code>
<div class="block">Executes the action for all of the input files that were removed since the previous task execution.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="isIncremental()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isIncremental</h4>
<pre>boolean&nbsp;isIncremental()</pre>
<div class="block">Indicates if it was possible for Gradle to determine which exactly input files were out of date compared to a previous execution.
 This is <em>not</em> possible in the case of no previous execution, changed input properties, output files, etc.
 <p>
 When <code>true</code>:
 </p>
 <ul>
     <li>Any input file that has been added or modified since previous execution will be considered 'out-of-date' and reported to <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a>.</li>
     <li>Any input files that has been removed since previous execution will be reported to <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#removed(org.gradle.api.Action)"><code>removed(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a>.</li>
 </ul>
 <p>
 When <code>false</code>:
 </p>
 <ul>
     <li>Every input file will be considered to be 'out-of-date' and will be reported to <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a>.</li>
     <li>No input files will be reported to <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#removed(org.gradle.api.Action)"><code>removed(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a>.</li>
 </ul></div>
</li>
</ul>
<a name="outOfDate(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>outOfDate</h4>
<pre>void&nbsp;outOfDate(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/tasks/incremental/InputFileDetails.html" title="interface in org.gradle.api.tasks.incremental">InputFileDetails</a>&gt;&nbsp;outOfDateAction)</pre>
<div class="block">Executes the action for all of the input files that are out-of-date since the previous task execution. The action may also be supplied as a <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang"><code>Closure</code></a>.
 <ul>
     <li>When <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#isIncremental()"><code>isIncremental()</code></a> == <code>true</code>, the action will be executed for any added or modified input file.</li>
     <li>When <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#isIncremental()"><code>isIncremental()</code></a> == <code>false</code>, the action will be executed for every input file for the task.</li>
 </ul>
 <p>
 This method may only be called a single time for a single <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html" title="interface in org.gradle.api.tasks.incremental"><code>IncrementalTaskInputs</code></a> instance.
 </p></div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalStateException.html?is-external=true" title="class or interface in java.lang">IllegalStateException</a></code> - on second and subsequent invocations.</dd></dl>
</li>
</ul>
<a name="removed(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>removed</h4>
<pre>void&nbsp;removed(<a href="../../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../../org/gradle/api/tasks/incremental/InputFileDetails.html" title="interface in org.gradle.api.tasks.incremental">InputFileDetails</a>&gt;&nbsp;removedAction)</pre>
<div class="block">Executes the action for all of the input files that were removed since the previous task execution. The action may also be supplied as a <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang"><code>Closure</code></a>.
 <ul>
     <li>When <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#isIncremental()"><code>isIncremental()</code></a> == <code>true</code>, the action will be executed for any removed input file.</li>
     <li>When <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#isIncremental()"><code>isIncremental()</code></a> == <code>false</code>, the action will not be executed.</li>
 </ul>
 <p>
 This method may only be called a single time for a single <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html" title="interface in org.gradle.api.tasks.incremental"><code>IncrementalTaskInputs</code></a> instance.
 </p><p>
 This method may only be called after <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a> has been called.
 </p></div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/IllegalStateException.html?is-external=true" title="class or interface in java.lang">IllegalStateException</a></code> - if invoked prior to <a href="../../../../../org/gradle/api/tasks/incremental/IncrementalTaskInputs.html#outOfDate(org.gradle.api.Action)"><code>outOfDate(org.gradle.api.Action&lt;? super org.gradle.api.tasks.incremental.InputFileDetails&gt;)</code></a>, or if invoked more than once.</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li><a href="../../../../../org/gradle/api/tasks/incremental/InputFileDetails.html" title="interface in org.gradle.api.tasks.incremental"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/gradle/api/tasks/incremental/IncrementalTaskInputs.html" target="_top">Frames</a></li>
<li><a href="IncrementalTaskInputs.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
